﻿/*
Deployment script for Sitecore.ReferenceData

This code was generated by a tool.
Changes to this file may cause incorrect behavior and will be lost if
the code is regenerated.
*/

GO
SET ANSI_NULLS, ANSI_PADDING, ANSI_WARNINGS, ARITHABORT, CONCAT_NULL_YIELDS_NULL, QUOTED_IDENTIFIER ON;

SET NUMERIC_ROUNDABORT OFF;

GO
PRINT N'Altering [xdb_refdata].[SaveDefinitions]...';


GO
ALTER PROCEDURE [xdb_refdata].[SaveDefinitions]
(
    @Definitions [xdb_refdata].[MonikerDefinitions] READONLY
)
WITH EXECUTE AS OWNER
AS
BEGIN
    SET NOCOUNT ON;

    SET TRANSACTION ISOLATION LEVEL READ UNCOMMITTED

    DECLARE
        @Results [xdb_refdata].[DefinitionResults],
        @CurrentDate DATETIME2(0) = CONVERT(DATETIME2(0), GETUTCDATE()),
        @DefinitionInstanceID UNIQUEIDENTIFIER,
        @Moniker NVARCHAR(MAX),
        @TypeID UNIQUEIDENTIFIER,
        @ID UNIQUEIDENTIFIER,
        @Version SMALLINT,
        @IsActive BIT,
        @DataTypeRevision SMALLINT,
        @Data VARBINARY(MAX),
        @IsUpdate BIT

    DECLARE InputDefinition CURSOR FOR
        SELECT [DefinitionInstanceID], [Moniker], [TypeID], [Version], [IsActive], [DataTypeRevision], [Data] FROM @Definitions

    OPEN InputDefinition

    FETCH NEXT FROM InputDefinition
        INTO @DefinitionInstanceID, @Moniker, @TypeID, @Version, @IsActive, @DataTypeRevision, @Data

    WHILE @@FETCH_STATUS = 0
    BEGIN
        BEGIN TRY
            SET @IsUpdate = 1

            SET @ID = [xdb_refdata].[GetDefinitionID](@Moniker, @TypeID)

            IF(@ID IS NULL)
            BEGIN

                BEGIN TRANSACTION [Definition]

                SET @ID = [xdb_refdata].[GetDefinitionID](@Moniker, @TypeID)

                IF(@ID IS NULL)
                BEGIN
                    SET @IsUpdate = 0
                    SET @ID = NEWID()

                    INSERT INTO
                        [xdb_refdata].[DefinitionMonikers]
                    (
                        [ID],
                        [Moniker],
                        [MonikerHash]
                    )
                    VALUES
                    (
                        @ID,
                        @Moniker,
                        [xdb_refdata].[GetDefinitionMonikerHash](@Moniker)
                    )

                    INSERT INTO [xdb_refdata].[Definitions]
                    (
                        [ID],
                        [Version],
                        [TypeID],
                        [IsActive],
                        [LastModified],
                        [DataTypeRevision],
                        [Data]
                    )
                    VALUES
                    (
                        @ID,
                        @Version,
                        @TypeID,
                        @IsActive,
                        @CurrentDate,
                        @DataTypeRevision,
                        @Data
                    )
                END

                COMMIT TRANSACTION [Definition]

            END

            IF EXISTS ( SELECT 1 FROM [xdb_refdata].[Definitions] WHERE [ID] = @ID AND [Version] = @Version )
            BEGIN
                UPDATE [xdb_refdata].[Definitions]
                SET
                    [TypeID] = @TypeID,
                    [IsActive] = @IsActive,
                    [LastModified] = @CurrentDate,
                    [DataTypeRevision] = @DataTypeRevision,
                    [Data] = @Data
                WHERE
                    [ID] = @ID AND
                    [Version] = @Version
            END
            ELSE
            BEGIN
                SET @IsUpdate = 0

                INSERT INTO [xdb_refdata].[Definitions]
                (
                    [ID],
                    [Version],
                    [TypeID],
                    [IsActive],
                    [LastModified],
                    [DataTypeRevision],
                    [Data]
                )
                VALUES
                (
                    @ID,
                    @Version,
                    @TypeID,
                    @IsActive,
                    @CurrentDate,
                    @DataTypeRevision,
                    @Data
                )
            END

            INSERT INTO @Results
            (
                [DefinitionInstanceID],
                [Moniker],
                [TypeID],
                [Version],
                [Success],
                [Message]
            )
            VALUES
            (
                @DefinitionInstanceID,
                @Moniker,
                @TypeID,
                @Version,
                1,
                CASE
                    WHEN @IsUpdate = 1
                        THEN 'UPDATE'
                    ELSE
                        NULL
                END
            )
        END TRY
        BEGIN CATCH
            IF(@@TRANCOUNT > 0)
            BEGIN
                ROLLBACK TRANSACTION [Definition]
            END

            INSERT INTO @Results
            (
                [DefinitionInstanceID],
                [Moniker],
                [TypeID],
                [Version],
                [Success],
                [Message]
            )
            VALUES
            (
                @DefinitionInstanceID,
                @Moniker,
                @TypeID,
                @Version,
                0,
                ERROR_MESSAGE()
            )
        END CATCH

        FETCH NEXT FROM InputDefinition
        INTO @DefinitionInstanceID, @Moniker, @TypeID, @Version, @IsActive, @DataTypeRevision, @Data
    END

    CLOSE InputDefinition
    DEALLOCATE InputDefinition

    SELECT
        [DefinitionInstanceID],
        [Moniker],
        [TypeID],
        [Version],
        [Success],
        [Message]
    FROM @Results
    AS Results
END
GO
PRINT N'Update complete.';


GO
